<template>
  <div class="domain-settings-content">
    <div class="settings-group-title" @click="isOpen = !isOpen" :class="{ open: isOpen }" v-if="!isModal">
      <i class="icon -cobalt" :class="{'chevron-down': isOpen, 'chevron-right': !isOpen}"></i>
      <div class="setting-group-icon">
        <i :class="'icon -cobalt role-' + (settingsGroup.role === PARTICIPANT_ROLES.EXPEDITOR.toLowerCase() ? 'client' : settingsGroup.role.toLowerCase())" v-if="settingsGroup.icon"></i>
      </div>
      <div class="title">{{settingsGroup.title}}</div>
      <div class="changed-count" v-if="changeCount > 0">{{changeCount}}</div>
      <div v-if="showDelete" @click.stop="$emit('delete', settingsGroup)" class="btn-delete">
        <i class="icon close -cobalt"></i>
      </div>
    </div>
    <div class="settings-group-content" :class="{'is-modal': isModal}" v-if="isOpen || isModal">
      <div v-if="settingsGroup.type !== 'limit' && !isExpeditor">
        <domain-settings-row
                v-for="(settingsRow, index) in settingsGroup.value"
                :key="index"
                :settings-row="settingsRow"
                :change-count="changeCount"
                @change-setting="changeSetting"
        ></domain-settings-row>
      </div>
      <div v-if="settingsGroup.type !== 'limit' && isExpeditor">
        <div
                v-for="(settingsRowGroup, index) in settingsGroup.value"
                :key="index"
                :index="index"
                :settings-row-group="settingsRowGroup"
        >
          <div class="acc-title" :class="{first: index === 0}">{{settingsRowGroup.title}}</div>
          <domain-settings-row
                  v-for="(settingsRow, index) in settingsRowGroup.value"
                  :key="index"
                  :settings-row="settingsRow"
                  :change-count="changeCount"
                  @change-setting="changeSetting"
          ></domain-settings-row>
        </div>
      </div>
      <div v-if="settingsGroup.type === 'limit'" style="width: 315px">
        <ob-input
                label="Лимит на создание или публикацию линка, мин"
                :value="settingsGroup.value"
                @input="onInputLimit"
        ></ob-input>
      </div>
      <div class="settings-group-controls">
        <ob-button label="Сохранить" :disabled="changeCount <= 0" @click="onSave"/>
        <ob-button v-if="isModal" label="Отмена" type="flat" @click="onClose"></ob-button>
        <ob-button label="Сбросить изменения" class="revert" v-if="changeCount > 0" type="flat" @click="onRevert"></ob-button>
      </div>
    </div>
  </div>
</template>

<script>
import { PARTICIPANT_ROLES } from '../../../resources/log_domains_const'
import DomainSettingsRow from "./DomainSettingsRow";
import ObButton from "common-components/src/obComponents/obButton";
import ObInput from "common-components/src/obComponents/obInput";
import debounce from 'debounce'
export default {
  name: 'DomainSettingsGroup',
  components: {ObInput, ObButton, DomainSettingsRow},
  props: {
    isExpeditor: {
      type: Boolean,
      default: false
    },
    showDelete: {
      type: Boolean,
      default: false
    },
    isModal: {
        type: Boolean,
        default: false
    },
    settingsGroup: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      isOpen: false,
      changedSettings: [],
      changeCount: 0,
      PARTICIPANT_ROLES
    }
  },
  methods: {
    changeSetting (row, access, status) {
      this.$emit('change-setting', row, access, status === null ? true : status, this.settingsGroup)
      if(status !== null) {
        if(status) this.changeCount++
        else this.changeCount--
      }
    },
    onSave () {
      this.$emit('save', this.settingsGroup)
      this.changeCount = 0
    },
    onRevert () {
      this.$emit('revert', this.settingsGroup)
      this.changeCount = 0
    },
    onClose () {
      this.$emit('close')
      this.changeCount = 0
    },
    onInputLimit: debounce(function(value){
      let status = String(this.settingsGroup.value) !== value ? this.changeCount !== 0 ? null : true : false
      this.changeSetting(
              this.settingsGroup,
              value,
              status
      )
    }, 200)
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  .settings-group-title {
    @include font-mixin(14px, 20px, 400, 0.2px, $cobalt);
    padding: 20px 20px 20px 64px;
    background: $white;
    border-top: 1px solid $lavender;
    position: relative;
    display: flex;
    .chevron-right, .chevron-down {
      font-size: 16px;
      position: absolute;
      top: 19px;
      left: 24px;
    }
    .btn-delete {
      cursor: pointer;
      display: none;
      padding: 0 5px;
    }
    .setting-group-icon {
      margin-right: 20px;
    }
    .title {
      flex-grow: 1;
    }
    &.open {
      border-bottom: 1px solid $lavender;
      .chevron-right, .chevron-down {
        top: 18px;
      }
    }
    &:hover {
      .btn-delete {
        display: block;
      }
    }
  }
  .acc-title {
    @include font-mixin(16px, 20px, 700, 1.6px, $cobalt);
    margin: 40px 0 20px;
    &.first {
      margin-top: 0;
    }
  }
  .changed-count {
    @include font-mixin(14px, 20px, 400, 1.2px, $cobalt-black);
    padding-left: 5px;
    white-space: nowrap;
    &::before {
      content: '';
      display: inline-block;
      vertical-align: top;
      background: $cobalt;
      border-radius: 50%;
      margin-right: 13px;
      margin-top: 6px;
      width: 5px;
      height: 5px;
    }
  }
  .settings-group-controls {
    padding-top: 40px;
    display: flex;
  }
  .settings-group-content {
    padding: 40px;
    &.is-modal {
      .revert {
        float: right;
      }
    }
  }
</style>
